unit fMain;

interface

uses
  Windows, Classes, Messages, Controls, Dialogs, Forms, StdCtrls, ComCtrls,
  SysUtils;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    RichEdit2: TRichEdit;
    procedure FormShow(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure DO_OnMessage(var Msg: TMsg; var Handled: Boolean);
    Function KeyCount(KeyWord:String;KeyLine:String):Integer;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
begin
  Application.OnMessage := DO_OnMessage;
  RichEdit1.SelStart:=0;
end;

procedure TForm1.DO_OnMessage(var Msg: TMsg; var Handled: Boolean);
begin

  if(ActiveControl is TRichEdit)  and
    (Msg.message=WM_KEYDOWN)  and
    (Msg.wParam=$09)          then //TAB
  begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
    Handled := True;
  end;
end;

procedure TForm1.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  I, J, K, L, TabCount, Py, iOldSize: Integer;
  TabPoint:TStringList;
  WordWidth:extended;
begin
  Py:=RichEdit1.CaretPos.y;
  case Key of
    VK_Return:
      begin
        TabCount:=KeyCount(#$20,RichEdit1.lines.Strings[Py]);
        RichEdit1.Paragraph.TabCount:=TabCount;//]wtabwIq

        TabPoint := TStringList.Create;
        try
          RichEdit2.Text:=RichEdit1.Lines.Strings[Py];//ȦsW@檺T
          L := Length(RichEdit2.Text);
          RichEdit2.SetFocus;
          I := 0;
          while ((K-1)<L) do begin
            K:=K+I;
            I := RichEdit2.SelStart+1;
            while (I<L) and (RichEdit2.Text[I]<>#$20) do Inc(I);
            while (I<L) and (RichEdit2.Text[I]=#$20)  do Inc(I);
            if I<L then Dec(I);
            RichEdit2.SelLength:=I;
            TabPoint.Add(inttostr(I));
            RichEdit2.SelStart:=I;
          end;

          TabPoint.Add(inttostr(Length(RichEdit2.Text)));//rꪺ̫][Jtab]w
          RichEdit1.SetFocus;//Х^Ӫa
          WordWidth:=(Canvas.TextWidth(RichEdit1.Lines.Strings[0]))/(Length(RichEdit1.Lines.Strings[0]))-1;//pre

          for i:=0 to RichEdit1.Paragraph.TabCount-1 do begin
            RichEdit1.Paragraph.Tab[i]:=strtoint(floattostr(Round(strtofloat(TabPoint[i])*WordWidth) div 1));
          end;
        finally
          FreeAndNil(TabPoint);
        end;
      end;
    end;
end;

Function TForm1.KeyCount(KeyWord:String;KeyLine:String):Integer;
  var i,j,PosCount:integer;//pŸƶq
begin
  PosCount:=0;
  RichEdit2.Text:=KeyLine;

  for i:=0 to Length(RichEdit2.Text)-1 do begin
   RichEdit2.text:=StringReplace(RichEdit2.Text,'  ',' ',[rfReplaceAll]);
    RichEdit2.SelStart:=i;
    RichEdit2.SelLength:=1;
    if RichEdit2.SelText=KeyWord then
      PosCount:=PosCount+1;
  end;
  result:=PosCount;
end;

end.
